/* Bed - v.pomey */

/* definition of the message base used by Bermuda */
/*   taken from the Bermuda source code  */

#define PRIVATE         0x0001          /* Flag private bit             */
#define CRASH           0x0002          /* Mail: crash message          */
#define RECEIVED        0x0004          /* Flag received bit            */
#define SENT            0x0008          /* Mail: msg has been sent      */
#define FILEATCH        0x0010          /*       msg has file attached  */
#define MSGFWD          0x0020          /*       msg has been send      */
#define KILLSEND        0x0080          /*       kill/send              */
#define ORPHAN          0x0040          /*       unknown destination    */
#define MSGLOCAL        0x0100          /*       message entered here   */
#define MSGHOLD         0x0200          /*       hold message for pickup*/
#define DIRECT          0x0400          /*       no route but no crash  */
#define NOKILL          0x0800          /*       no kill by crunch      */
#define CARBONCOPY      0x4000			/* internal flag */
#define DELETED         0x8000          /* Flag deleted bit             */

struct Hdr {
 char   from[36],                       /* User who created msg         */
        to[36],                         /* User who may read msg        */
        topic[72],                      /* Topic of msg                 */
        time[20];                       /* Date/Time string of message  */
 long   create,                         /* Date when MSGS was received  */
        Mstart;                         /* Start offset of message      */
 ushort up,                             /* NC                           */
        parent,                         /* Parent # of this msg         */
        flags,                          /* Attribute bits               */
        mailer[8],                      /* needed for the mailer        */
        size,                           /* # bytes in message           */
        reads,                          /* Number of times read         */
        cost,                           /* Cost of message*100          */
        Ozone,
        Onet,                           /* Net on which msg was created */
        Onode,                          /* Node on which msg was created*/
        Opoint,
        Dzone,
        Dnet,                           /* Destination net for msg      */
        Dnode,                          /* Destination node for msg     */
        Dpoint;
};

/****************************************************************/

extern int ourzone, ournet, ournode, ourpoint;
extern char sysop[80];
extern int  curr_area, num_msgs, curr_msg;
extern FILE *texts;
extern struct Hdr *headers;

#define MaxAreas 100
int num_areas;			/* number of areas */
struct _areas {
	char area_name[50];
	char area_file[100];
	int  flags;
	int  lastread;
} areas[MaxAreas];

int readconfig(void);
int readareas(void);

#define BedVersion "0.2"
#define FALSE 0
#define TRUE  1
